# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.790985
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from keap_core_v2_client.models.default_commission import DefaultCommission
from keap_core_v2_client.models.product_commission import ProductCommission
from keap_core_v2_client.models.subscription_commission import SubscriptionCommission
from typing import Optional, Set
from typing_extensions import Self

class AffiliateProgramV2(BaseModel):
    """
    AffiliateProgramV2
    """ # noqa: E501
    affiliate_id: Optional[StrictStr] = Field(default=None, description="The affiliate_Id for Affiliate commission program")
    create_time: Optional[StrictStr] = Field(default=None, description="The created time of affiliate commission program")
    default_commission: Optional[DefaultCommission] = None
    id: Optional[StrictStr] = Field(default=None, description="The affiliate commission program name")
    name: Optional[StrictStr] = Field(default=None, description="The affiliate commission program name")
    notes: Optional[StrictStr] = Field(default=None, description="The affiliate commission program notes")
    priority: Optional[StrictStr] = Field(default=None, description="The Affiliate commission program priority")
    product_commissions: Optional[List[ProductCommission]] = None
    subscription_commissions: Optional[List[SubscriptionCommission]] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["affiliate_id", "create_time", "default_commission", "id", "name", "notes", "priority", "product_commissions", "subscription_commissions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AffiliateProgramV2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of default_commission
        if self.default_commission:
            _dict['default_commission'] = self.default_commission.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in product_commissions (list)
        _items = []
        if self.product_commissions:
            for _item_product_commissions in self.product_commissions:
                if _item_product_commissions:
                    _items.append(_item_product_commissions.to_dict())
            _dict['product_commissions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in subscription_commissions (list)
        _items = []
        if self.subscription_commissions:
            for _item_subscription_commissions in self.subscription_commissions:
                if _item_subscription_commissions:
                    _items.append(_item_subscription_commissions.to_dict())
            _dict['subscription_commissions'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AffiliateProgramV2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "affiliate_id": obj.get("affiliate_id"),
            "create_time": obj.get("create_time"),
            "default_commission": DefaultCommission.from_dict(obj["default_commission"]) if obj.get("default_commission") is not None else None,
            "id": obj.get("id"),
            "name": obj.get("name"),
            "notes": obj.get("notes"),
            "priority": obj.get("priority"),
            "product_commissions": [ProductCommission.from_dict(_item) for _item in obj["product_commissions"]] if obj.get("product_commissions") is not None else None,
            "subscription_commissions": [SubscriptionCommission.from_dict(_item) for _item in obj["subscription_commissions"]] if obj.get("subscription_commissions") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


