# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.790985
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class UpdatedPaymentPlan(BaseModel):
    """
    UpdatedPaymentPlan
    """ # noqa: E501
    auto_charge: Optional[StrictBool] = None
    days_between_payments: Optional[StrictInt] = None
    days_between_retries: Optional[StrictInt] = None
    initial_payment_amount: Optional[Union[StrictFloat, StrictInt]] = None
    initial_payment_date: Optional[StrictStr] = Field(default=None, description="ISO date of the initial payment in pay plan. e.g 2024-04-28")
    max_charge_attempts: Optional[StrictInt] = None
    number_of_payments: Optional[StrictInt] = None
    payment_method_id: Optional[StrictStr] = None
    plan_start_date: Optional[StrictStr] = Field(default=None, description="ISO date of the start of pay plan. e.g 2024-04-28")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["auto_charge", "days_between_payments", "days_between_retries", "initial_payment_amount", "initial_payment_date", "max_charge_attempts", "number_of_payments", "payment_method_id", "plan_start_date"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdatedPaymentPlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdatedPaymentPlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "auto_charge": obj.get("auto_charge"),
            "days_between_payments": obj.get("days_between_payments"),
            "days_between_retries": obj.get("days_between_retries"),
            "initial_payment_amount": obj.get("initial_payment_amount"),
            "initial_payment_date": obj.get("initial_payment_date"),
            "max_charge_attempts": obj.get("max_charge_attempts"),
            "number_of_payments": obj.get("number_of_payments"),
            "payment_method_id": obj.get("payment_method_id"),
            "plan_start_date": obj.get("plan_start_date")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


